xfstests: Test FITRIM where length is smaller than FSB
authorLukas Czerner <lczerner@redhat.com>
Tue, 16 Oct 2012 09:41:33 +0000 (09:41 +0000)
committerRich Johnston <rjohnston@sgi.com>
Wed, 24 Oct 2012 17:43:33 +0000 (12:43 -0500)
This tests corner case in FITRIM implementation where range size is
smaller than file system block or zero. In this case FITRIM should fail
with EINVAL.

The problem was spotted in xfs and ext4 where in case of length = 0 the
'end' variable underflowed. In case of length smaller than 1 FSB FITRIM
finished successfully, but we really should rather return EINVAL in both
cases.

(This patch has to be applied after 'Use upstream version of fstrim
instead of the local one')

Signed-off-by: Lukas Czerner <lczerner@redhat.com>
Reviewed-by: Dave Chinner <dchinner@redhat.com>
Signed-off-by: Rich Johnston <rjohnston@sgi.com>
288 [new file with mode: 0644]
288.out [new file with mode: 0644]
group

diff --git a/288 b/288
new file mode 100644 (file)
index 0000000..944ca50
--- /dev/null
+++ b/288
@@ -0,0 +1,58 @@
+#!/bin/bash
+# FS QA Test No. 288
+#
+# This check the FITRIM argument handling in the corner case where length is
+# smaller than block size of zero.
+#
+#-----------------------------------------------------------------------
+# Copyright 2012 (C) Red Hat, Inc., Lukas Czerner <lczerner@redhat.com>
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+
+owner=lczerner@redhat.com
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+status=0
+trap "exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+
+_require_fstrim
+_require_scratch
+
+_scratch_mkfs >/dev/null 2>&1
+_scratch_mount
+_test_batched_discard $SCRATCH_MNT || _notrun "FITRIM not supported on $SCRATCH_DEV"
+
+echo "[+] Length is zero (should fail)"
+out=$("$FSTRIM_PROG" -v -o0 -l0 $SCRATCH_MNT 2>&1)
+[ $? -eq 0 ] && status=1
+echo $out | _filter_scratch
+
+echo "[+] Length is smaller than block size (should fail)"
+out=$("$FSTRIM_PROG" -v -o0 -l100 $SCRATCH_MNT 2>&1)
+[ $? -eq 0 ] && status=1
+echo $out | _filter_scratch
+
+echo "Test done"
+exit
diff --git a/288.out b/288.out
new file mode 100644 (file)
index 0000000..a4e2d7b
--- /dev/null
+++ b/288.out
@@ -0,0 +1,6 @@
+QA output created by 288
+[+] Length is zero (should fail)
+fstrim: SCRATCH_MNT: FITRIM ioctl failed: Invalid argument
+[+] Length is smaller than block size (should fail)
+fstrim: SCRATCH_MNT: FITRIM ioctl failed: Invalid argument
+Test done
diff --git a/group b/group
index f52c5d5746ac8d8297164c754917d2f7651feb0a..fb0f8ebc808ad60437365d792b5cc41a580248a7 100644 (file)
--- a/group
+++ b/group
@@ -406,3 +406,4 @@ deprecated
 285 auto rw
 286 other
 287 auto dump quota quick
 285 auto rw
 286 other
 287 auto dump quota quick
+288 auto quick ioctl trim